{!author name="Bart Goossens"}
{!doc category="Samples/Basic/Spectrum analyzer"}
{!title name="Image spectrum analyzer using FFT"}

% Section: Overview
%
% This sample illustrates how the Quasar runtime library functions
% <fft2>, <log>, <abs>, <fftshift2> can be used to build a spectrum
% analyzer for an image.
% 
import "system.q"

% Function: spectrum_analyzer
%
% Computes the power spectrum of the specified input image.
function img_out = spectrum_analyzer(img_in)
    rescale = x -> (x - min(x)) / (max(x) - min(x)) * 255
    spec = rescale(log(abs(fft2(img_in))+1e-8))
    img_out = fftshift2(spec)
end

function [] = main()
    img_in = imread("lena_big.tif")
    img_out = spectrum_analyzer(img_in)
    imshow(img_out)
end
