{!author name="Bart Goossens"}
{!doc category="Samples/Basic/Connect figures"}
{!title name="Synchronized image displays"}

% Section: Overview
%
% Example of displaying three separate images that are connected to each other,
% so that when zooming in one image, the other images are also automatically
% scaled. This technique is very useful when comparing the results of several
% image processing techniques.
%
im = imread("lena_big.tif")[:,0..255,:]

fig1=imshow(im)
fig2=imshow(im+25*randn(size(im)))
fig3=imshow(im+15*randn(size(im)))
fig1.connect(fig2)
fig1.connect(fig3)
