{!author name="Bart Goossens"}
{!doc category="Samples/Graphics/Animated plot"}
{!title name="Animated plot example"}

% Section: Overview
%
% This demo shows how plots can be animated with OpenGL rendering. 
% It suffices to create a form with a display control. Then on this
% display control, the plot function is invoked. The plot function
% returns an object of the class 'qplot'. This object is updated
% to use OpenGL rendering.
% 

import "Quasar.UI.dll"

function [] = main()

    frm = form("Animated plot demo (Lissajous curves)")
    frm.width = 600
    frm.height = 800
    frm.center()

    x = (0..511)/512 
    r = (0..9999)/10000

    disp = frm.add_display()
    disp2 = frm.add_display()

    a = 1.0
    step = 0.01
    init = true
    while !frm.closed()
        
        a += step
        if step > 0 && a > 8 || step < 0 && a < 1
            step = -step
        endif
        
        disp.plot(sin((8+a)*pi*x),cos(12*pi*x))
        if init
            xlim([-1.1,1.1])
            ylim([-1.1,1.1])
            xlabel("x")
            ylabel("y")
            title("Animated plot (256 points)")
        endif

        disp2.plot(sin((8+a)*pi*r),cos(12*pi*r)).set_renderer("opengl")
        if init
            xlim([-1.1,1.1])
            ylim([-1.1,1.1])
            xlabel("x")
            ylabel("y")
            title("Animated scatter plot (10000 points)")
        endif
        init = false
        pause(0.01)
    end

end