%REQUIRES_DISPLAY
{!author name="Bart Goossens"}
{!doc category="Samples/Graphics/FillPoly"}
{!title name="OpenGL polygon filling example"}

% Section: Overview
%
% Shows how to render a simple polygon with flat coloring. A drawing layer is added to a
% qimshow object.
% 
import "Quasar.UI.dll"

function [] = main()
    frm = form()
    dsp = frm.add_display()
    lyr = new(qvectorlayer)
    ims = dsp.imshow(zeros(480,640),[0,1])
    ims.addlayer(lyr)
    phi = pi/8
    phi_delta = 0.01
    
    while !frm.closed()
        phi += phi_delta
        if phi > pi/4 || pi < -pi/4
            phi = -phi
        endif
        lyr.clear()
        lyr.draw_bracket([240,320],100,20,phi)
        lyr.draw_bracket([240,320],100,20,-phi)
        ims.update()
        pause(25)
    endwhile
endfunction

function [] = draw_bracket(self:^qvectorlayer,loc:vec2,height:scalar,width:scalar,angle:scalar)
    self.setpencolor("cyan")
    self.setbrushcolor("red")
    crnrs = zeros(7,2)
    crnrs[0,0..1] = loc-[0,width/2]
    crnrs[1,0..1] = loc+[height,height*tan(angle) - width/2]
    crnrs[2,0..1] = loc+[height,height*tan(angle) + width/2]
    crnrs[3,0..1] = loc+[0,width/2]
    crnrs[4,0..1] = loc+[-height,height*tan(angle) + width/2]
    crnrs[5,0..1] = loc+[-height,height*tan(angle) - width/2]
    crnrs[6,0..1] = loc-[0,width/2]
    self.fillpoly(crnrs[:,[1,0]])
endfunction