% dither.q
% Aug 2014
{!author name="Bart Goossens"}
{!doc category="Samples/Image Processing/Dithering"}
{!title name="Shows how to implement an error diffusion operation"}

% Section: Overview
%
% Illustration of error diffusion, using a serial loop
%
% The error diffusion code is serial and Quasar detects that the loop needs to be executed
% serially.
% 
im = imread("lena_big.tif")

Q = 64 % R/G/B quantization factor
im_out = round(im / Q) * Q


tic()

for m=0..size(im,0)-1
    for n=0..size(im,1)-1
        for k=0..size(im,2)-1
            v = im[m,n,k]
            v -= (im_out[m-1,n,k] - im[m-1,n,k])/2
            v -= (im_out[m,n-1,k] - im[m,n-1,k])/2            
            v -= (im_out[m-1,n+1,k] - im[m-1,n+1,k])/4
            v = round(v / Q) * Q
            im_out[m,n,k] = saturate(v/255)*255
        end
    end
end    
toc("Error diffusion")

imshow(im_out)
