#include <cstdio>
#include <cstdlib>
#include <cstring>

#if defined(WIN32) || defined(WIN64)
#include <conio.h>
#include <Windows.h>
#endif


extern void sample1();
extern void sample2();
extern void sample3();
extern void sample4();
extern void sample5();
extern void sample6();
extern void sample7();
extern void sample8();
extern void sample9();
extern void sample10();
extern void sample11();
extern void sample12();
extern void sample13();
extern void sample14();
extern void sample15();
extern void sample16();
extern void sample17();
extern void sample18();
extern void sample19();
extern void sample20();
extern void sample21();
extern void sample22();
extern void sample23();
extern void test_qlibs();
extern void test_memleaks();
extern void test_lrefs();
extern void test_constructors();

struct Sample
{
    const char * name;
    void (*func)(void);
};

Sample samples[] = {{"sample1", sample1},
                    {"sample2", sample2},
                    {"sample3", sample3},
                    //{"sample4", sample4},  -- requires OpenCV installation
                    //{"sample5", sample5},  -- requires OpenCV installation
                    {"sample6", sample6},
                    {"sample7", sample7},
                    {"sample8", sample8},
                    {"sample9", sample9},
                    {"sample10", sample10},
					//{"sample11", sample11},   -- requires CUDA environment
					//{"sample12", sample12},   -- requires OpenCL installation
					{"sample13", sample13},
					{"sample15", sample15},
					{"sample16", sample16},
					{"sample17", sample17},
					{"sample18", sample18},
					{"sample20", sample20},
					{"sample21", sample21},
                    {"sample22", sample22},
                    {"sample23", sample23},
};

void pause()
{
    #if defined(WIN32) || defined(WIN64)
    printf("Press any key to continue.\n");
    _getch();
    #endif
}

int main(int argc, char *argv[])
{

    if (argc != 2)
    {
        printf("Needs one additional parameter (the sample to run)\n");
        pause();
        return 1;
    }

    char sample_name[256];
    snprintf(sample_name, sizeof(sample_name), "%hs", argv[1]);

    for (int i = 0; samples[i].name != NULL; i++)
    {
        if (strcmp(sample_name, samples[i].name) == 0)
        {
            samples[i].func();
            pause();
            return 0;
        }
    }
    printf("Unknown sample: %s\n", sample_name);
    pause();
    return 0;
}
