# Interop samples - C++ API

This folder contains the `lib_read_dataset` sample. It contains a C++ library that exposes the function `read_dataset` to Quasar. The sample shows how C++ functions can be exported to Quasar. Using the C++ API it is even possible to get access to the CUDA / OpenCL pointers (see documentation).

A CMake file `CMakeLists.txt` is included to compile the samples. The program can be compiled as follows:

    # Linux
    cmake .  
    make

    # Windows (Visual Studio 2017)
    cmake -G "Visual Studio 15 2017" -A x64

Note that the environment variable `QUASAR_INCL_PATH` needs to point to the Quasar include directory (containing `quasar.h`, `quasar_dsl.h`), this may require some readjustment. For example:

    cmake . -DQUASAR_INCL_PATH=~/quasar/Quasar/include

Make sure that the compiled library (for example `lib_read_dataset.64.so` or `lib_read_dataset.64.dll`) is in the same directory as `lib_read_dataset_test.q`.

The sample can then be executed using 

    ./quasar lib_read_dataset_test.q

When finished, the program prints the size of the data matrix that was loaded:

	[19, 34]

