
import pyquasar as q


def main():

    q.init("cpu")

    pi = 3.14159265359
    N = 1024
    T = 1.0 / 100.0
    x = q.linspace(0.0, N*T, N)
    samples = q.sin(50.0 * 2.0*pi*x) + 0.5*q.sin(80.0 * 2.0*pi*x) + 0.01 * q.rand(1, N)

    q.print(q.min(samples), " to ", q.max(samples))

    dft = q.fft1(samples)
    q.print(dft[0:9])

    xdft = q.abs(q.fft1(samples))
    q.print(q.min(xdft), " to ", q.max(xdft))
    #return
    xdft = xdft.to_py()

    xf = q.linspace(0.0, 1.0/(2.0*T), N/2)

    q.plot(xdft) #[:N//2])
    

    try:
        import numpy as np
        import matplotlib.pyplot as plt
        import scipy.fftpack

        yf = scipy.fftpack.fft(samples.to_py())
    
        fig, ax = plt.subplots()
        ax.plot(xf.to_py(), 2.0/N * np.abs(yf[:N//2]))
        plt.show()

    except:
        print("An exception occurred")

    q.run_gui()

if __name__ == '__main__':
    main()
