%DISABLED
{!author name="Bart Goossens"}
{!doc category="Samples/Video Processing/Video transcoding"}
{!title name="Video transcoding sample"}

% Section: Overview
% 
% This example demonstrates how the Quasar video library can be used to transcode
% video files from one format to another format.
%
% See also:
%  <vidopen>, <vidsave>, <vidreadframe>, <vidwriteframe>
%
import "inttypes.q"
import "Quasar.Video.dll"

function [] = main()
       
    in_file_name = "Media/streetColor.avi"
    out_file_name = "Media/streetColor_out.avi"

    % open the input video
    in_stream = vidopen(in_file_name)
    print "in_stream=",in_stream

    codec_settings = object()
    codec_settings.encoder = "mpeg4" % guess from filename
    codec_settings.video_bit_rate = 5000000 % bits per second
    codec_settings.frame_width = in_stream.frame_width
    codec_settings.frame_height = in_stream.frame_height
    codec_settings.bits_per_color = 8
    codec_settings.avg_frame_rate = in_stream.avg_frame_rate % same as original
    codec_settings.gop_size = 10 % periodicity of the I-frames

    % open the output video
    out_stream = vidsave(out_file_name, codec_settings)
    print "out_stream=",out_stream
    frame_count = 0
    
    while vidreadframe(in_stream)               
        frame = float(in_stream.rgb_data)

        % Do some processing here...

        %print in_stream.pts
        % Important - need to make sure that frame is converted to uint8!
        vidwriteframe(out_stream, in_stream.pts, float_to_uint8(frame))
        frame_count += 1
    endwhile
    
    print frame_count, " frames converted!"

    % explicitly closes the input/output streams (this is optional)
    outstream = null
    instream = null

endfunction