#
# The Python project allows Python programmers to use functions from Quasar.
# This is achieved by simply importing pyquasar (the Quasar language bridge).
# Note that in order to do so, pyquasar.pyd / pyquasar.so must be available.
#
import numpy as np
import pyquasar as q

q.init("cpu")
q.import_dll("Quasar.UI.dll")

# Constructs Quasar values and adds them
a = q.value([5,4,3,2,1]) + q.value(2.0) 

# Convert to a NumPy array
print(a.to_py())

# Open an image
im = q.imread("lena_big.tif")
print("Before: ", q.size(im))

# Range selector (in Quasar)
im = im[128:(128+255),128:(128+255),:]
print("After: ", q.size(im))

print("Range: ", q.min(im), "-", q.max(im))

# Displays the image
q.imshow(im)
q.run_gui()
