%
% TensorFlow-Quasar test program
% Demonstrate how to make TensorFlow calls from Quasar
% Note: make sure Python 3.6/3.7/3.8 is installed with tensorflow (pip install tensorflow)
%
import "pyquasar.${BITNESS}.${NATIVEEXT}"

function y : cube'unchecked = uint8_to_float(x : cube[uint8]'unchecked)
    y = uninit(size(x))
    {!parallel for}
    for [m,n,p]=0..size(x,0..2)-1
        y[m,n,p] = float(x[m,n,p])
	endfor
endfunction

function [] = main()
	py = pyimport("builtins")
	np = pyimport("numpy")
	tf = pyimport("tensorflow")

	mnist = tf.keras.datasets.mnist

	[train, test] = mnist.load_data().from_py()
	[x_train, y_train] = train 
	[x_test, y_test] = test 
	%save("mnist.qd", x_train, y_train, x_test, y_test)

	x_train = uint8_to_float(x_train) / 255.0
	y_train = reshape(uint8_to_float(y_train) / 255.0,[60000,1])  % Interpreter: dimensions changed?
	print "size(x_train)=", size(x_train), " size(y_train)=", size(y_train)

	y_train = np.reshape(y_train, pyint([60000,1,1]))
	y_test = np.reshape(y_test, pyint([10000,1,1]))

	model = tf.keras.models.Sequential(py.list({
	  tf.keras.layers.Flatten(input_shape:=py.list(pyint([28, 28]))),
	  tf.keras.layers.Dense(128, activation:="relu"),
	  tf.keras.layers.Dropout(0.2),
	  tf.keras.layers.Dense(10, activation:="softmax")
	}))

	model.compile(optimizer="adam",
				  loss="sparse_categorical_crossentropy",
				  metrics=py.list({"accuracy"}))

	model.fit(x_train, y_train, epochs:=pyint(5))
	model.evaluate(x_test, y_test, verbose:=pyint(2))
endfunction

