% This program demonstrates how to use OpenCV from Quasar
% A webcam will be opened and the result is shown in an OpenCV window.
% Note: requires that the following dependencies are installed:
% - Python 3.6 or higher
% - OpenCV + Python cv2
% - PyQuasar
import "pyquasar.${BITNESS}.${NATIVEEXT}"

py = pyimport("builtins")
np = pyimport("numpy")
cv2 = pyimport("cv2")

cap = cv2.VideoCapture(pyint(0))
fourcc = cv2.VideoWriter_fourcc("X","V","I","D")
record_to_file = false
if record_to_file
	out = cv2.VideoWriter("output.avi",fourcc, 20.0, pytuple([1920,1080]))
endif

while true
    [ret, frame] =  cap.read().from_py()
    gray = cv2.cvtColor(frame, pyint(cv2.COLOR_BGR2GRAY))
	if record_to_file
		out.write(frame)
	endif
    cv2.imshow("frame",gray)
    if and(cv2.waitKey(pyint(1)), 0FFh) == py.ord("q")
        break
	endif
endwhile
	
cap.release()
if record_to_file
	out.release()
endif

cv2.destroyAllWindows()
