#pragma once

namespace quasar
{
	//============================================================================
	// implementation of several builtin types
	//============================================================================
	#ifndef DBL_SCALAR
	IMPLEMENT_SCALAR_TYPE(TYPE_SCALAR, float, _T("scalar"));
	IMPLEMENT_SCALAR_TYPE(TYPE_DOUBLESCALAR, double, _T("scalar'double"));
	IMPLEMENT_TYPE(TYPE_COMPLEXSCALAR, cscalar_t<float>, _T("cscalar"));
	IMPLEMENT_TYPE(TYPE_DOUBLECOMPLEXSCALAR, cscalar_t<double>, _T("cscalar"));
	#else
	IMPLEMENT_SCALAR_TYPE(TYPE_SINGLEFLOAT, float, _T("scalar'single"));
	IMPLEMENT_SCALAR_TYPE(TYPE_SCALAR, double, _T("scalar"));
	IMPLEMENT_TYPE(TYPE_COMPLEXSCALAR, cscalar_t<double>, _T("cscalar"));
	IMPLEMENT_TYPE(TYPE_FLOATCOMPLEX, cscalar_t<float>, _T("cscalar"));
	#endif
	IMPLEMENT_SCALAR_TYPE(TYPE_HALFSCALAR, __half, _T("scalar'half"));
	IMPLEMENT_TYPE(TYPE_HALFCOMPLEXSCALAR, cscalar_t<__half>, _T("scalar'half"));
	IMPLEMENT_SCALAR_TYPE(TYPE_INT, int, _T("int"));
	IMPLEMENT_TYPE(TYPE_VEC, Vector, _T("vec"));
	IMPLEMENT_TYPE(TYPE_MAT, Matrix, _T("mat"));
	IMPLEMENT_TYPE(TYPE_CUBE, Cube, _T("cube"));
	IMPLEMENT_TYPE(TYPE_CVEC, CVector, _T("cvec"));
	IMPLEMENT_TYPE(TYPE_CMAT, CMatrix, _T("cmat"));
	IMPLEMENT_TYPE(TYPE_CCUBE, CCube, _T("ccube"));
	IMPLEMENT_TYPE(TYPE_STRING, string_t, _T("string"));
	IMPLEMENT_SCALAR_TYPE(TYPE_INT8, int8_t, _T("int8"));
	IMPLEMENT_SCALAR_TYPE(TYPE_INT16, int16_t, _T("int16"));
	IMPLEMENT_SCALAR_TYPE(TYPE_INT64, int64_t, _T("int64"));
	IMPLEMENT_SCALAR_TYPE(TYPE_UINT8, uint8_t, _T("uint8"));
	IMPLEMENT_SCALAR_TYPE(TYPE_UINT16, uint16_t, _T("uint16"));
	IMPLEMENT_SCALAR_TYPE(TYPE_UINT32, uint32_t, _T("uint32"));
	IMPLEMENT_SCALAR_TYPE(TYPE_UINT64, uint64_t, _T("uint64"));
	IMPLEMENT_TYPE(TYPE_VOID, qvalue_t, _T("??"));
#ifndef _MSC_VER
	template <>
#endif
	IMPLEMENT_TYPE(TYPE_VOID, void, _T("??"));
#ifndef _MSC_VER
	template <>
#endif
	IMPLEMENT_TYPE(TYPE_INT, bool, _T("int"));

	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<4>, _T("cube{4}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<5>, _T("cube{5}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<6>, _T("cube{6}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<7>, _T("cube{7}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<8>, _T("cube{8}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<9>, _T("cube{9}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<10>, _T("cube{10}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<11>, _T("cube{11}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<12>, _T("cube{12}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<13>, _T("cube{13}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<14>, _T("cube{14}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<15>, _T("cube{15}"));
	IMPLEMENT_TYPE(TYPE_NCUBE, NCube<16>, _T("cube{16}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<4>, _T("ccube{4}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<5>, _T("ccube{5}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<6>, _T("ccube{6}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<7>, _T("ccube{7}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<8>, _T("ccube{8}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<9>, _T("ccube{9}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<10>, _T("ccube{10}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<11>, _T("ccube{11}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<12>, _T("ccube{12}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<13>, _T("ccube{13}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<14>, _T("ccube{14}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<15>, _T("ccube{15}"));
	IMPLEMENT_TYPE(TYPE_NCCUBE, NCCube<16>, _T("ccube{16}"));

	IMPLEMENT_TYPE(TYPE_VEC, scalar1, _T("vec1"));
	IMPLEMENT_TYPE(TYPE_VEC, scalar2, _T("vec2"));
	IMPLEMENT_TYPE(TYPE_VEC, scalar3, _T("vec3"));
	IMPLEMENT_TYPE(TYPE_VEC, scalar4, _T("vec4"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<5>, _T("vec5"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<6>, _T("vec6"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<7>, _T("vec7"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<8>, _T("vec8"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<9>, _T("vec9"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<10>, _T("vec10"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<11>, _T("vec11"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<12>, _T("vec12"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<13>, _T("vec13"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<14>, _T("vec14"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<15>, _T("vec15"));
	IMPLEMENT_TYPE(TYPE_VEC, scalarN<16>, _T("vec16"));

	IMPLEMENT_TYPE(TYPE_CVEC, cscalar1, _T("cvec1"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalar2, _T("cvec2"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalar3, _T("cvec3"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalar4, _T("cvec4"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<5>, _T("cvec5"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<6>, _T("cvec6"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<7>, _T("cvec7"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<8>, _T("cvec8"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<9>, _T("cvec9"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<10>, _T("cvec10"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<11>, _T("cvec11"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<12>, _T("cvec12"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<13>, _T("cvec13"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<14>, _T("cvec14"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<15>, _T("cvec15"));
	IMPLEMENT_TYPE(TYPE_CVEC, cscalarN<16>, _T("cvec16"));

	IMPLEMENT_TYPE(TYPE_VEC, int1, _T("ivec1"));
	IMPLEMENT_TYPE(TYPE_VEC, int2, _T("ivec2"));
	IMPLEMENT_TYPE(TYPE_VEC, int3, _T("ivec3"));
	IMPLEMENT_TYPE(TYPE_VEC, int4, _T("ivec4"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<5>, _T("ivec5"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<6>, _T("ivec6"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<7>, _T("ivec7"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<8>, _T("ivec8"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<9>, _T("ivec9"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<10>, _T("ivec10"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<11>, _T("ivec11"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<12>, _T("ivec12"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<13>, _T("ivec13"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<14>, _T("ivec14"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<15>, _T("ivec15"));
	IMPLEMENT_TYPE(TYPE_VEC, intN<16>, _T("ivec16"));

}